Index: /extensions/event_cats/include/evntcats_admin_funcs.inc.php
===================================================================
--- /extensions/event_cats/include/evntcats_admin_funcs.inc.php	(revision 4328)
+++ /extensions/event_cats/include/evntcats_admin_funcs.inc.php	(revision 4329)
@@ -63,4 +63,21 @@
 
 /*
+ * ec_end2()
+ * Process repetitive task when error in database modifying functions.
+ *
+ * @param
+ *   $n : number to display
+ * @return
+ *   false as this function is used when there is a problem
+ */
+function ec_end2($n) {
+  global $page;
+  $page['errors'][] =
+   sprintf(l10n('ec_DB_problem'), $n).
+   'MySQL error '.mysql_errno().', "'.mysql_error().'"';
+  return false;
+}
+
+/*
  * ec_create_user_OK()
  * Creates new generic user and eventually new group as described in $_POST.
@@ -92,5 +109,5 @@
   }
   else
-   $page['infos'][] = l10n('ec_user_create_OK').$_POST['login'];
+   $page['infos'][] = sprintf(l10n('ec_user_create_OK'), $_POST['login']);
   if (
     pwg_query("
@@ -100,7 +117,7 @@
     ") !== false
   )
-   $page['infos'][] = l10n('ec_user_generic_OK').$_POST['login'];
+   $page['infos'][] = sprintf(l10n('ec_user_generic_OK'), $_POST['login']);
   else
-   $page['errors'][] =l10n('ec_user_generic_pb').$_POST['login'];
+   $page['errors'][] = sprintf(l10n('ec_user_generic_pb'), $_POST['login']);
   
   // New group creation if required,
@@ -124,8 +141,9 @@
       ");
     if ($t4)
-     $page['infos'][]=l10n('ec_group_create_OK').$_POST['groupname'];
+     $page['infos'][] =
+      sprintf(l10n('ec_group_create_OK'), $_POST['groupname']);
     if (!$t3)
      $page['errors'][] =
-      l10n('ec_group_create_pb').' (1) ; '.
+      sprintf(l10n('ec_group_create_pb'), $_POST['groupname']).' (1) : '.
       'MySQL error '.mysql_errno().', "'.mysql_error().'"';
     if (
@@ -135,12 +153,10 @@
       ") === false
     ) $page['errors'][] =
-     l10n('ec_group_create_pb').' (2) ; '.
+      sprintf(l10n('ec_group_create_pb'), $_POST['groupname']).' (2) : '.
      'MySQL error '.mysql_errno().', "'.mysql_error().'"';
-    else
-     $page['infos'][] =
-      $_POST['login'].
-      l10n('ec_group_create_OK2').
-      $_POST['groupname']
-     ;
+    else $page['infos'][] = sprintf(
+      l10n('ec_group_create_OK2'),
+      $_POST['login'], $_POST['groupname']
+    );
   }
   return $ec_user_id;
@@ -206,10 +222,10 @@
   
   if (!isset($_POST['ec_act1']))
-   return ec_end1('ec_act1', 'ec_bad_argument1');
+   return ec_end1('ec_act1', 'Bad argument : ');
   
   if (
     ($_POST['ec_act1']) != 'toggle_forced' and
     !isset($_POST['ec_input_action'])
-  ) return ec_end1('ec_input_action', 'ec_bad_argument1');
+  ) return ec_end1('ec_input_action', 'Bad argument : ');
   
   $is_creation = true;
@@ -234,10 +250,10 @@
         !isset($_POST['ec_in_up_code']) or
         !ereg('^[a-zA-Z0-9_-]{4,32}$', $_POST['ec_in_up_code'])
-      ) return ec_end1('ec_in_up_code', 'ec_bad_argument7');
+      ) return ec_end1('ec_in_up_code', 'Improper code : ');
       else $ec_code = $_POST['ec_in_up_code'];
       
       foreach ($ec_lists['ec_table'] as $ec_entry)
        if ($ec_code == $ec_entry['code'])
-        return ec_end1('ec_in_up_code', 'ec_bad_argument2');
+        return ec_end1('ec_in_up_code', 'Code already exists : ');
       
       if (
@@ -246,5 +262,5 @@
           $_POST['ec_sel_user'] != 'old'
         )
-      ) return ec_end1('ec_sel_user', 'ec_bad_argument1');
+      ) return ec_end1('ec_sel_user', 'Bad argument : ');
     
     case 'modify_entry_submit':
@@ -256,14 +272,14 @@
             !isset($_POST['login']) or
             $_POST['login'] == ''
-          ) return ec_end1('login', 'ec_bad_argument1');
+          ) return ec_end1('login', 'Bad argument : ');
           if (in_array($_POST['login'], $ec_lists['user_ids']))
-           return ec_end1('login', 'ec_bad_argument3');
+           return ec_end1('login', 'User already exists : ');
         }
         elseif ($_POST['ec_sel_user'] == 'old') {
           if (!isset($_POST['ec_in_up_usr_list']))
-           return ec_end1('login', 'ec_bad_argument1');
+           return ec_end1('login', 'Bad argument : ');
           $ec_user_id = $_POST['ec_in_up_usr_list'];
           if (!array_key_exists($ec_user_id, $ec_lists['user_ids']))
-           return ec_end1('ec_in_up_usr_list', 'ec_bad_argument6');
+           return ec_end1('ec_in_up_usr_list', 'User doesn\'t exist : ');
         }
         else $action = 'ec_nok';
@@ -279,5 +295,7 @@
         !isset($_POST['ec_entry_sel']) or
         !array_key_exists($_POST['ec_entry_sel'], $ec_lists['ec_table'])
-      ) return ec_end1('ec_entry_sel', 'ec_bad_argument5');
+      ) return ec_end1(
+        'ec_entry_sel', 'Code doesn\'t exist or non-duplicable code : '
+      );
       
       // Other checks for user type and value
@@ -324,8 +342,10 @@
       if (!array_key_exists($_POST['ec_entry_sel'],
        $ec_lists['duplicable_codes']['ids'])
-      ) return ec_end1('ec_entry_sel', 'ec_bad_argument5');
+      ) return ec_end1(
+        'ec_entry_sel', 'Code doesn\'t exist or non-duplicable code : '
+      );
       
     break;
-    default: ec_end1('ec_act1', 'ec_bad_argument1');
+    default: ec_end1('ec_act1', 'Bad argument : ');
   }
   // Pfew !
@@ -336,5 +356,5 @@
       case 'add_p': // Additional Page
         if (isset($_POST['ec_in_up_aps'])) $arg2 = $_POST['ec_in_up_aps'];
-        else ec_end1('ec_in_up_aps', 'ec_bad_argument1');
+        else ec_end1('ec_in_up_aps', 'Bad argument : ');
         $arg1 = 'NULL';
       break;
@@ -345,9 +365,9 @@
           if ($_POST['ec_input_action'] == 'img') {
             if (isset($_POST['ec_in_up_img'])) $arg2 = $_POST['ec_in_up_img'];
-            else ec_end1('ec_in_up_img', 'ec_bad_argument1');
+            else ec_end1('ec_in_up_img', 'Bad argument : ');
           }
           else $arg2 = 'NULL';
         }
-        else ec_end1('ec_in_up_cat', 'ec_bad_argument1');
+        else ec_end1('ec_in_up_cat', 'Bad argument : ');
       break;
       case 'home':    // Home : nothing to do : "arg"s are ''
@@ -355,5 +375,5 @@
         $arg1 = 'NULL'; $arg2 = 'NULL';
       break;
-      default: ec_end1('ec_input_action', 'ec_bad_argument1');
+      default: ec_end1('ec_input_action', 'Bad argument : ');
     }
     
@@ -361,5 +381,5 @@
     $forced = (isset($_POST['ec_in_up_forced'])) ? 'true' : 'false';
     if ($_POST['ec_act1'] == 'duplicate_entry_submit' and $forced == 'true')
-     return ec_end1('ec_in_up_forced', 'ec_bad_argument1');
+     return ec_end1('ec_in_up_forced', 'Bad argument : ');
     
     // User and eventually group creation, if needed
@@ -384,5 +404,5 @@
       AND `forced`  = '".$forced."'
   "))) !== false) { // print("<pre>$arg1 $arg2<br>$q</pre>");
-    $page['errors'][] = l10n('ec_entry_already_exists').$t1[0];
+    $page['errors'][] = sprintf(l10n('ec_entry_already_exists'), $t1[0]);
     return false;
   }
@@ -440,5 +460,5 @@
     ) {
       $page['errors'][] =
-       l10n('ec_entry_create_pb').
+       l10n('ec_entry_create_pb').' : '.
        'MySQL error '.mysql_errno().', "'.mysql_error().'"'
       ;
@@ -449,5 +469,5 @@
       $forced = ($forced == 'false') ? '' : l10n('ec_cnfrm_forced');
       $page['infos'][] =
-       l10n('ec_entry_create_OK').mysql_insert_id().' : '.
+       sprintf(l10n('ec_entry_create_OK'), mysql_insert_id()).' : '.
        $ec_code.' => '.
        $ec_lists['user_ids'][$ec_user_id].$forced
@@ -470,10 +490,12 @@
     ) {
       $page['errors'][] =
-       l10n('ec_entry_create_pb').
+       l10n('ec_entry_create_pb').' : '.
        'MySQL error '.mysql_errno().', "'.mysql_error().'"'
       ;
       $ret = false;
     }
-    else $page['infos'][] = l10n('ec_entry_modify_OK').$_POST['ec_entry_sel'];
+    else $page['infos'][] = sprintf(
+      l10n('ec_entry_modify_OK'), $_POST['ec_entry_sel']
+    );
   }
   build_ec_lists();
@@ -492,19 +514,15 @@
 function ec_delete_entry_OK($ec_id) {
   global $page;
-  if (!pwg_query("
+  if (pwg_query("
     DELETE FROM `".EVNTCATS_TABLE."`
     WHERE `id` = ".$ec_id
-  )) {
+  ) === false) {
     $page['errors'][] =
-     l10n('ec_entry_del_nok_pre').
-     $ec_id.
-     l10n('ec_entry_del_nok_end').
+     sprintf(l10n('ec_entry_del_nok'),
+     $ec_id).
      'MySQL error '.mysql_errno().', "'.mysql_error().'"';
     return false;
   }
-  else $page['infos'][] =
-   l10n('ec_entry_del_ok_pre').
-   $ec_id.
-   l10n('ec_entry_del_ok_end');
+  else $page['infos'][] = sprintf(l10n('ec_entry_del_ok'), $ec_id);
   return true;
 }
Index: /extensions/event_cats/include/evntcats_main_funcs.inc.php
===================================================================
--- /extensions/event_cats/include/evntcats_main_funcs.inc.php	(revision 4328)
+++ /extensions/event_cats/include/evntcats_main_funcs.inc.php	(revision 4329)
@@ -180,6 +180,6 @@
  */
 function build_ec_addp() {
-  global $ec_lists, $ec_ap_ok;
-  if ($ec_ap_ok) {
+  global $ec_lists;
+  if (EC_AP_OK) {
     $res = pwg_query("SELECT `id`, `title` FROM `".ADD_PAGES_TABLE."`");
     while ($r = mysql_fetch_assoc($res)) {
@@ -244,5 +244,5 @@
  */
 function build_ec_table() {
-  global $ec_lists, $ec_ap_ok;
+  global $ec_lists;
   
   $q = pwg_query("
@@ -287,5 +287,5 @@
       case 2: // Additional Page
         if (
-          $ec_ap_ok and (
+          EC_AP_OK and (
             is_in($ec_entry['action'], 'ec_ok') or
             $ec_entry['action'] == 'ec_nok'
@@ -322,6 +322,4 @@
 function build_ec_lists() {
   
-  global $ec_ap_ok, $template, $ec_lists, $conf;
-  
   // Construction of $ec_lists['add_pages'] array var
   build_ec_addp();
@@ -373,5 +371,5 @@
         FROM ".EVNTCATS_TABLE."
         WHERE `code` IS NULL
-          AND `arg1` = '1'
+          AND `arg1` = 1
           AND `arg2` IS NOT NULL
       ;",
@@ -385,7 +383,7 @@
     array_from_query("
       SELECT `arg2`
-        FROM ".EVNTCATS_TABLE."
+        FROM `".EVNTCATS_TABLE."`
         WHERE `code` IS NULL
-          AND `arg1` = '2'
+          AND `arg1` = 2
           AND `arg2` IS NOT NULL
       ;",
@@ -400,6 +398,15 @@
   $users_granted_ids = array();
   
+  $c = (count($t = mysql_fetch_row(pwg_query("
+    SELECT `arg2`
+    FROM `".EVNTCATS_TABLE."`
+    WHERE `code` IS NULL
+      AND `arg1` = 3
+      AND `arg2` IS NOT NULL
+    LIMIT 1;
+  "))) == 0) ? 0 : intval($t[0]);
+  
   $users_granted_thks_gen_ids = array();
-  if ($ec_gen_granted = (read_ec_conf('duplic_gen') != '0')) {
+  if ($ec_gen_granted = (($c & 8) != 0)) {
     $users_granted_thks_gen_ids = order_by_name(
       array_diff(
@@ -425,6 +432,5 @@
   $types_granted_ids = array();
   $users_granted_thks_types_ids = array();
-  $c = intval(read_ec_conf('duplic_type'));
-  if ($c != 0) {
+  if (($c & 7) != 0) {
     if (($c & 1) != 0) $types_granted_ids[] = '1';
     if (($c & 2) != 0) $types_granted_ids[] = '2';
@@ -547,5 +553,5 @@
   // Returns an array which values are all the user_ids allowed to display a
   // "duplicate" link. The keys of this array are strange (for direct allowed
-  // users, keys are usernames), but normally not used
+  // users, keys are usernames), but should not used
   return $users_granted_ids;
 }
@@ -561,5 +567,5 @@
  */
 function dup_allowed($user_id) {
-  return true;
+  return in_array($user_id, build_dup_arrays());
 }
 
Index: /extensions/event_cats/language/fr_FR/duplic.lang.php
===================================================================
--- /extensions/event_cats/language/fr_FR/duplic.lang.php	(revision 4328)
+++ /extensions/event_cats/language/fr_FR/duplic.lang.php	(revision 4329)
@@ -7,6 +7,6 @@
 */
 
-$lang['Duplicate']         = 'Dupliquer';
-$lang['Duplicate account'] = 'Créer un compte avec les mêmes propriétés';
+$lang['Duplicate']                                 = 'Dupliquer';
+$lang['Create a new account with same properties'] = 'Créer un compte avec les mêmes propriétés';
 
 ?>
